﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Net;
using System.Net.Sockets;
using System.Text;
using System.Threading;
using System.Windows.Forms;

using System.Diagnostics;

/// <Objetivos>
/// Enviar broadcast a la camara (listo)
/// Guardar datos enviados por la camara (listo)
/// Setear datos de la camara mediante http request (listo)
/// Enviar muchos broadcast hasta que la camara responda (listo)
/// La interfaz suba los datos de manera automatica (listo)
/// Sistema que pueda identificar si es primera vez que es seteado los usuarios(listo)
/// Guardar datos obtenidos y seteados en .txt para que pueda ser leido por el programa principal(listo)
/// Si esta mal el nombre de usuario y/o password terminar programa (listo)
/// Visualizador de lo que esta pasando (listo)
/// boton para cerrar (listo)
/// guardar .txt con la informacion en la misma carpeta donde estará el software de interfaz
/// ser capaz de decidir que cosas setear (con un check box)
/// Que busque una cantidad limitada de veces la cámara (10) (listo)
/// </Objetivos>

namespace Setup_Camera_ip
{
    public partial class Form1 : Form
    {
        // Camera ip login info

        private string Wifi_mode = "0";

        private string Camera;
        private string http_response;

        private int number_attempt;

        private bool isSetup;

        private const int Broadcast_send_port = 10000;
        private const int Broadcast_receive_port = 10001;

        private const string filename1 = "Setup_information.txt";
        private const string information_text = "\nAprieta el botón Search para buscar la camara ip en la red local\n";
        private const string setup_text = "\nAprieta el botón Setup para setear los usuarios y sus password, la red wifi a la que la camara se va a conectar, además de seteos básicos.\n"+
                                           "Sólo aquellos check box que estén con ticket se setearan.";

        private UdpClient udp_receive_broadcast;
        private UdpClient udp_send_broadcast;

        private System.Windows.Forms.Timer Timer_Request_broadcast;
        private System.Windows.Forms.Timer Timer_drop_receive;        

        private static Camera_info info = new Camera_info();

        private delegate void delegar_show();

        private delegate void delegar_Status_label(string text);

        delegar_Status_label label;

        private delegate void delegar_UserText(string text);

        delegar_UserText User_Text;

        private Thread Camera_Thread;

        public Form1()
        {
            InitializeComponent();

            Timer_Request_broadcast = new System.Windows.Forms.Timer();
            Timer_Request_broadcast.Interval = 5000;
            Timer_Request_broadcast.Tick += new EventHandler(Tick_Request_Broadcast);

            Timer_drop_receive = new System.Windows.Forms.Timer();
            Timer_drop_receive.Interval = 500;
            Timer_drop_receive.Tick += new EventHandler(Tick_drop_receive);

            label = delegate(string status) { Status_label.Text = status; };

            User_Text = delegate(string txt) { UserTextBox.AppendText(txt); UserTextBox.SelectionStart = UserTextBox.Text.Length; UserTextBox.ScrollToCaret(); }; 

            number_attempt = 0;

            isSetup = true;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            UserTextBox.AppendText("Información de la Cámara:\n");

            UserTextBox.AppendText(information_text);

            Read_File();           
        }

        private void Read_File()
        {
            try
            {
                string info_setup = File.ReadAllText(filename1, Encoding.ASCII);

                int a = info_setup.IndexOf("Wifi: ");
                int b = info_setup.IndexOf(" ", a);
                int c = info_setup.IndexOf("\n", b);

                Wifi_id.Text = info_setup.Substring(b + 1, c - 1 - b);

                a = info_setup.IndexOf("Admin_User: ");
                b = info_setup.IndexOf(" ", a);
                c = info_setup.IndexOf("\n", b);

                Old_user.Text = info_setup.Substring(b + 1, c - 1 - b);
                Admin_user.Text = info_setup.Substring(b + 1, c - 1 - b);

                a = info_setup.IndexOf("Operator_User: ");
                b = info_setup.IndexOf(" ", a);
                c = info_setup.IndexOf("\n", b);

                Oper_User.Text = info_setup.Substring(b + 1, c - 1 - b);

                a = info_setup.IndexOf("Password: ");
                b = info_setup.IndexOf(" ", a);
                c = info_setup.IndexOf("\n", b);

                Old_pass.Text = info_setup.Substring(b + 1, c - 1 - b);
                Pass_User.Text = info_setup.Substring(b + 1, c - 1 - b);

               Debug.WriteLine(info_setup);
               UserTextBox.AppendText(info_setup);
            }

            catch (Exception ex)
            {
               Debug.WriteLine(ex.ToString());
               UserTextBox.AppendText("No existe archivo con información de la cámara.");
               Old_user.Text = "admin";
               Old_pass.Text = "";
            }
        }

        private void Tick_drop_receive(object sender, EventArgs e)
        {               
            if(udp_receive_broadcast != null)
            {
                udp_receive_broadcast.Close();
            }

            Timer_drop_receive.Enabled = false;
        }

        private void Tick_Request_Broadcast(object sender, EventArgs e)
        {
            if (number_attempt < 10)
            {
                send_broadcast("MO_I", new byte[] { 0, 0 });                
            }
            else
            {
                Timer_Request_broadcast.Enabled = false;
                Status_label.Text = "Ready";
            }
        }
        
        private void send_broadcast(string header, byte[] op)
         {   
             try
             { // Se escoge el puerto en el que se esta enviando el broadcast
                 udp_send_broadcast = new UdpClient(Broadcast_receive_port);

                 //udp_send_broadcast.Connect("192.168.1.255", Broadcast_send_port);
                 udp_send_broadcast.Connect("255.255.255.255", Broadcast_send_port);

                 //Sends a message to the host to which you have connected.

                 Byte[] sendBytes = Encoding.ASCII.GetBytes(header);

                 sendBytes = sendBytes.Concat(op).ToArray();

                 Byte[] sendBytes1 = {0x00,
                                      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
                                      0x04, 0x00, 0x00, 0x00,
                                      0x00, 0x00, 0x00, 0x00,
                                      0x00, 0x00, 0x00, 0x01};

                 sendBytes = sendBytes.Concat(sendBytes1).ToArray();

                 udp_send_broadcast.Send(sendBytes, sendBytes.Length);

                 udp_send_broadcast.Close();

                 Debug.WriteLine("Broadcast enviado");

                 UserTextBox.AppendText("\nRecuperando información de la Cámara: Intento " + number_attempt.ToString() + "\n");
                 UserTextBox.SelectionStart = UserTextBox.Text.Length; 
                 UserTextBox.ScrollToCaret();

                 number_attempt = number_attempt + 1;

                 receive_broadcast();
             }
             catch (Exception ex)
             {
                Debug.WriteLine(ex.ToString());
             }

         }

        private void receive_broadcast()
        {
            try
            {
                udp_receive_broadcast = new UdpClient();

                IPEndPoint receiveEndPoint = new IPEndPoint(IPAddress.Any, Broadcast_receive_port);

                udp_receive_broadcast.Client.Bind(receiveEndPoint);

                Timer_drop_receive.Enabled = true;

                udp_receive_broadcast.BeginReceive(_Callback, udp_receive_broadcast);                
                
            }

            catch (Exception ex)
            {
               Debug.WriteLine(ex.ToString());
            }
        }

        private void _Callback(IAsyncResult iar)
        {
            try
            {
                UdpClient client = (UdpClient)iar.AsyncState;

                IPEndPoint ipRemote = new IPEndPoint(IPAddress.Any, 0);

                byte[] rgb = client.EndReceive(iar, ref ipRemote);

                data_save(rgb);

                delegar_show Mostrar = new delegar_show(show_info);

                this.Invoke(Mostrar);

                client.Close();

                Timer_Request_broadcast.Enabled = false;

                Debug.WriteLine("recibido");

                this.Invoke(User_Text, "Información de la Cámara encontrada\n");               

            }

            catch (ObjectDisposedException)
            {
               Debug.WriteLine("closing listening socket");
            }

            catch (Exception exc)
            {
               Debug.WriteLine("Listening socket error: \"" + exc.Message + "\"");
            }

        }

        private void data_save(byte[] data)
        {
            byte[] msj = new byte[66];

            System.Buffer.BlockCopy(data, 23, msj, 0, msj.Length-1);          

            info.Identification_number = Encoding.UTF8.GetString(msj, 0, 13);

            info.Nombre = Encoding.UTF8.GetString(msj, 13, 13 + 21);

            byte[][] lan_aux = new byte[4][];

            for (int i = 0; i < 4; i++)
            {
                lan_aux[i] = new byte[4] {0, 0, 0, 0};

                System.Buffer.BlockCopy(msj, 13 + 21 +i*4, lan_aux[i], 0, 4);
            }

            info.Lan_setup = lan_aux;

            string aux = "";

            for (int i = 13 + 21 + 4*5; i < 13 + 21 + 4*5 + 4; i++)
            {
                if (i != 13 + 21 + 4 * 5 + 4 - 1)
                    aux = aux + msj[i].ToString() + ".";
                else
                    aux = aux + msj[i].ToString();
            }

            info.Sys = aux;

            aux = "";

            for (int i = 13 + 21 + 4 * 5 + 4; i < 13 + 21 + 4 * 5 + 4 + 4; i++)
            {
                if (i != 13 + 21 + 4 * 5 + 4 + 4 - 1)
                    aux = aux + msj[i].ToString() + ".";
                else
                    aux = aux + msj[i].ToString();
            }

            info.App = aux;

            info.Lan_Port = ((msj[13 + 21 + 4 * 5 + 4 + 4] << 8) + msj[13 + 21 + 4 * 5 + 4 + 4 + 1]).ToString();

            info.dhcp_enable = msj[msj.Length - 1].Equals(1);
        }

        private void Search_button_Click(object sender, EventArgs e)
        {
            Status_label.Text = "loading";

            number_attempt = 0;

            send_broadcast("MO_I", new byte[]{0,0});            

            Timer_Request_broadcast.Enabled = true;            
        }

        private void Setup_button_Click(object sender, EventArgs e)
        {
            Status_label.Text = "Setting Camera";

            UserTextBox.Clear();

            this.Invoke(User_Text, "Seteando la Cámara:\n");

            isSetup = true;

            Send_command();

        }

        private void Close_button_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void show_info()
        {
            ID_text.Text = info.Identification_number;
            Name_text.Text = info.Nombre;

            byte[][] aux = info.Lan_setup;

            Ip_text1.Text = aux[0][0].ToString();
            Ip_text2.Text = aux[0][1].ToString();
            Ip_text3.Text = aux[0][2].ToString();
            Ip_text4.Text = aux[0][3].ToString();

            Port_text.Text = info.Lan_Port;

            Mask_text1.Text = aux[1][0].ToString();
            Mask_text2.Text = aux[1][1].ToString();
            Mask_text3.Text = aux[1][2].ToString();
            Mask_text4.Text = aux[1][3].ToString();

            gateway_text1.Text = aux[2][0].ToString();
            gateway_text2.Text = aux[2][1].ToString();
            gateway_text3.Text = aux[2][2].ToString();
            gateway_text4.Text = aux[2][3].ToString();

            dns_text1.Text = aux[3][0].ToString();
            dns_text2.Text = aux[3][1].ToString();
            dns_text3.Text = aux[3][2].ToString();
            dns_text4.Text = aux[3][3].ToString();

            dhcp_text.Text = info.dhcp_enable.ToString();

            sys_text.Text = info.Sys;

            app_text.Text = info.App;

            Status_label.Text = "Ready";
        }

        private void Setup(string set_name, string command, string verification, bool IsOldUser)
        {
            Debug.WriteLine(set_name);
            this.Invoke(User_Text, "\n" + set_name);

            if (isSetup)
            {
                try
                {
                    //set 
                    HttpWebRequest Request;

                    if (IsOldUser)
                    { Request = (HttpWebRequest)WebRequest.Create("http://" + Camera + command + "&user=" + Old_user.Text + "&pwd=" + Old_pass.Text); }

                    else
                    { Request = (HttpWebRequest)WebRequest.Create("http://" + Camera + command + "&user=" + Admin_user.Text + "&pwd=" + Pass_User.Text); }


                    HttpWebResponse Response = (HttpWebResponse)Request.GetResponse();

                    // Gets the stream associated with the response.
                    Stream stream = Response.GetResponseStream();

                    http_response = Stream2string(stream);

                    Debug.WriteLine("Response stream received.");
                    Debug.Write(http_response);

                    if (http_response.IndexOf(verification) != -1)
                    {
                        Debug.WriteLine("Success\n");
                        this.Invoke(User_Text, ": Success\n");
                    }

                    else
                    {
                        Debug.WriteLine("Error\n");
                        this.Invoke(User_Text, ": Error\n");
                        isSetup = false;
                    }

                    Response.Close();
                    stream.Close();
                }

                catch (Exception e)
                {
                    Debug.WriteLine(e.ToString());
                    Debug.WriteLine("Error\n");
                    this.Invoke(User_Text, ": Error\n");
                    isSetup = false;
                }
            }

            else 
            { 
                Debug.WriteLine("Error\n");
                this.Invoke(User_Text, ": Error\n");
            }
        }

        // Metodo necesario para hacer un request del tipo Http a la camara ip
        private void http_request()
        {
            if (Setup_User_checkBox.Checked)
            {
                Setup("Set Users", "/set_users.cgi?&user1=" + Admin_user.Text + "&pwd1=" + Pass_User.Text + "&pri1=2&user2=" + Oper_User.Text + "&pwd2=" + Pass_User.Text + "&pri2=1&user3=&pwd3=&pri3=0&user4=&pwd4=&pri4=0&user5=&pwd5=&pri5=0&user6=&pwd6=&pri6=0&user7=&pwd7=&pri7=0&user8=&pwd8=&pri8=0", "ok", true);

                Setup("Set Alias", "/set_alias.cgi?alias=" + Camera_Alias.Text, "ok", false);
            }

            if (Setup_Wifi_checkBox.Checked)
            {
                Setup("Scan Wifi", "/wifi_scan.cgi?", "ok", false);

                if (isSetup)
                {
                    this.Invoke(User_Text, "\nEspere 20 Segundos\n");
                    // wait time for the camera could scan all the wifi
                    Thread.Sleep(20000);
                }

                Setup("Get Wifi", "/get_wifi_scan_result.cgi?", Wifi_id.Text, false);

                if (isSetup)
                {
                    Wifi_mode = extract_WifiMode(http_response);
                }

                Setup("Set Wifi", "/set_wifi.cgi?&channel=5&enable=1&ssid=" + Wifi_id.Text + "&mode=0&encrypt=" + Wifi_mode + "&authtype=0&keyformat=0&defkey=0&key1=&key2=&key3=&key4=&key1_bits=0&key2_bits=0&key3_bits=0&key4_bits=0&wpa_psk=" + Wifi_pass.Text + "&country=1", "ok", false);
            }


            Setup("Set PTZ", "/set_misc.cgi?&ptz_center_onstart=0&ptz_patrol_rate=1&ptz_patrol_up_rate=0&ptz_patrol_down_rate=0&ptz_patrol_left_rate=0&ptz_patrol_right_rate=0&ptz_disable_preset=0&ptz_preset_onstart=0&ptz_patrol_h_rounds=1&ptz_patrol_v_rounds=1", "ok", false);

            //Setup("Go to center", "/decoder_control.cgi?&command=25", "ok", false);            

            //if (isSetup)
            //{
            //    this.Invoke(User_Text, "\nEspere 10 Segundos\n");
            //    // wait time for the could move to the center
            //    Thread.Sleep(10000);
            //}

            //Setup("Set presset 1", "/decoder_control.cgi?&command=30", "ok", false);
            
            Setup("Reboot", "/reboot.cgi?", "ok", false);

            if (isSetup)
            {
                Writing_File();

                this.Invoke(label, "Ready");
            }
        }

        private string extract_WifiMode(string msj)
        {
            int index = msj.IndexOf(Wifi_id.Text, 0);

            int a = msj.IndexOf("ap_security", index);

            int b = msj.IndexOf("=", a);

            return msj.Substring(b+1, 1);
        }

        // Metodo que genera un nuevo hilo para enviar los comandos de movimiento a la camara ip
        public void Send_command()
        {
            Camera = info.Lan_setup[0][0].ToString() + "." + info.Lan_setup[0][1].ToString() + "." + info.Lan_setup[0][2].ToString() + "." + info.Lan_setup[0][3].ToString() + ":" + info.Lan_Port;
                        
            // se genera un nuevo hilo parametrizado
            Camera_Thread = new Thread(new ThreadStart(http_request));
            Camera_Thread.Start();            
        }

        private string Stream2string(Stream stream)
        {
            MemoryStream copy = new MemoryStream();

            byte[] response = new byte[copy.Length];

            stream.CopyTo(copy);

            response = copy.ToArray();

            copy.Close();

            return Encoding.ASCII.GetString(response);
        }

        private void Writing_File()
        {
           string header = "Camera Setup Information\n";
           header = header + "Created a " + DateTime.Now.ToShortDateString() + " at " + DateTime.Now.ToLongTimeString() + "\n\n";
                      
           File.WriteAllText(filename1, header);

           string line = "Ip: " + Camera + "\n";
           line = line + "Wifi: " + Wifi_id.Text + "\n";
           line = line + "Admin_User: " + Admin_user.Text +"\n";
           line = line + "Operator_User: " + Oper_User.Text + "\n";
           line = line + "Password: " + Pass_User.Text + "\n";

           File.AppendAllText(filename1, line);
        }

        private void tabControl1_SelectedIndexChanged(object sender, EventArgs e)
        {
            UserTextBox.Clear();

            if (tabControl1.SelectedIndex == 0)
            {
                UserTextBox.AppendText(information_text);
            }
            else 
            {
                UserTextBox.AppendText(setup_text);
            }
        }

        private void Setup_User_checkBox_CheckedChanged(object sender, EventArgs e)
        {
            groupBox1.Enabled = Setup_User_checkBox.Checked;
        }

        private void Setup_Wifi_checkBox_CheckedChanged(object sender, EventArgs e)
        {
            groupBox2.Enabled = Setup_Wifi_checkBox.Checked;
        }


    }
}
