/*
 * pid.cpp
 *
 * Created: 10/04/2015 14:31:05
 *  Author: Reta
 */

#include "pid.h"
 
pid::pid(double * ref, double * kp, double * kd, double * ki)
{
	Ref = ref;	
	P = kp;
	D = kd;
	I = ki;
	E = 0;	
	restart_errors();
}

void pid::restart_errors()
{
	errores[0] = 0;	// error[i]
	errores[1] = 0;	// error[i] - error[i - 1]
	errores[2] = 0; // sum(error[z], z = 0..i)
}

void pid::calc(double val, uint32_t time)
{		
	double error = (*Ref) - val;
	
	errores[1] = error - errores[0];
	errores[0] = error;
	errores[2] = errores[2] + errores[0];
	
	E = (*P)*errores[0] + ((*D)*1000*errores[1]/(time)) + ((*I)*errores[2]*(time)/1000.0f);
	
	if (E > 10) E = 10;
	else if (E < -10) E = -10;
}