/*
 * encoder.cpp
 *
 * Created: 24/06/2015 10:56:34
 *  Author: Reta
 */ 

#include "encoder.h"

encoder::encoder(double * alp, volatile uint8_t * Ddr, volatile uint8_t * Port, volatile uint8_t * In, volatile uint8_t * Imsk, uint8_t Pin_A, uint8_t Pin_B):A(Ddr, Port, Pin_A), B(Ddr, Port, Pin_B)	
{
	count = 0;
	old_count = 0;
	new_count = 0;
	diff_count = 0;
	old_time = 0;
	new_time = 0;
	diff_time = 0;
	old_vel = 0;
	new_vel = 0;
	alpha = alp;
	//isMoving = false;
	//isDirection = false;
	//isForward = false;	
	stateA = false;
	//stateB = false;
	
	A.input(In, true, Imsk);
	//B.input(In, true, Imsk);
}

void encoder::Set_enable(bool enable)
{
	stateA = A.read();
	A.set_interrupt_enable(enable);
	//B.set_interrupt_enable(enable);
}

void encoder::reset()
{
	count = 0;
	old_count = 0;
	new_count = 0;
	old_time = 0;
	new_time = 0;
	old_vel = 0;
	new_vel = 0;
	//isMoving = false;
	//isDirection = false;
}

void encoder::update()
{
	cli();
	new_count = count;
	new_time = timer1::now();
	sei();
}

void encoder::cal_vel()
{
	diff_count = new_count - old_count;
	diff_time = new_time - old_time;
	
	//vel = Conv_m_Seg*diff_count/diff_time;	// m/seg
	new_vel = Conv_rpm*((double)diff_count)/((double)diff_time);	// rpm
	//vel = Conv_rpm*diff_count/diff_time;	// rpm
	
	new_vel = new_vel*(*alpha) + (1 - (*alpha))*old_vel;
	old_vel = new_vel;
	
	old_count = new_count;
	old_time = new_time;
}

void encoder::Interrupt_Count_Handler()
{
	//Serial.Send_string("interrupt on port B\n");
	//if(!isMoving)							//if wasn't moving, save the state
	//{
		////Serial.Send_string("Enc1 is starting to move\n");
		//
		//stateA = A.read();
		////stateB = B.read();
		//isMoving = true;
	//}
	
	//else if (!isDirection)//if didn't know the direction
	//{
		////Serial.Send_string("Enc1 decide the direction\n");
		//
		//if (A.read() != stateA)		//if state of A is different
		//{
			////Serial.Send_string("Enc2 A is different\n");
			//
			//stateA = !stateA;
			//
			//if(stateB)
			//{
				//if(stateA)	isForward = false;
				//else		isForward = true;
			//}
			//else
			//{
				//if(stateA)	isForward = true;
				//else		isForward = false;
			//}
		//}
		//
		//else if(B.read() != stateB)	//if state of B is different
		//{
			////Serial.Send_string("Enc1 B is different\n");
			//
			//stateB = !stateB;
			//
			//if(stateA)
			//{
				//if(stateB)	isForward = true;
				//else		isForward = false;
			//}
			//else
			//{
				//if(stateB)	isForward = false;
				//else		isForward = true;
			//}
		//}
		//
		//isDirection = true;
		//count++;
		//
	//}
	//else
	//{
		//Serial.Send_string("Enc1 is moving\n");
		
		if (A.read() != stateA)		//if state of A is different
		{
			stateA = !stateA;			// Enc1.stateA = ~Enc1.stateA
			count++;
		}
		//else if(B.read() != stateB)	//if state of B is different
		//{
			//stateB = !stateB;			// Enc1.stateB = ~Enc1.stateB
			//count++;
		//}
	//}
}

