/*
 * encoder.h
 *
 * Created: 24/06/2015 10:56:24
 *  Author: Reta
 */ 


#ifndef ENCODER_H_
#define ENCODER_H_

#include <avr/io.h>
#include <stdint.h> // needed for uint_8
#include <stdbool.h> //needed for boolean type
#include "../../Gpio/gpio.h"
#include "../../Timer/timer.h"
#include "../../Uart/uart.h"


class encoder
{	
	//variables
	public:	
		uint32_t	count;
		uint32_t	old_count;
		uint32_t	new_count;
		uint32_t	diff_count;
		uint32_t	old_time;
		uint32_t	new_time;
		uint32_t	diff_time;
		double		old_vel;
		double		new_vel;
		double	*	alpha;
		//bool		isMoving;
		//bool		isDirection;
		//bool		isForward;		
		bool		stateA;
		//bool		stateB;		
		gpio A;
		gpio B;
		
		
	private:
			
	//methods
	public:
				encoder(double * alp, volatile uint8_t * Ddr, volatile uint8_t * Port, volatile uint8_t * In, volatile uint8_t * Imsk, uint8_t Pin_A, uint8_t Pin_B);
		void	Set_enable(bool enable);
		void	reset();
		void	update();
		void	cal_vel();
		void	Interrupt_Count_Handler();
};




#endif /* ENCODER_H_ */