/*
 * timer.cpp
 *
 * Created: 16/04/2015 18:08:26
 *  Author: Reta
 */ 

#include "timer.h"

timer1::timer1()
{	
		
}

	
uint32_t	timer1::millis = 0;
uint8_t		timer1::fract = 0;
bool		timer1::isOn = false;	

void timer1::setup()
{
	OCR1AH = 0x00;				// Set compare to 255
	OCR1AL = 0xFF;
	
	TCCR1B |= (1 << WGM12);		// Mode 4, CTC on OCR1A
	TIMSK1 |= (1 << OCIE1A);	//Set interrupt on compare match	
}

// set period of timer 1 to 4us
void timer1::start()
{
	if(!isOn)
	{
		TCCR1B |= ((1 << CS10) | (1 << CS11)); // set prescaler to 64
		isOn = true;
	}
		
}

void timer1::stop()
{
	if(isOn)
	{
		TCCR1B &= ~((1 << CS10) | (1 << CS11) | (1 << CS12));
		isOn = false;
	}
	
	millis = 0;
	fract = 0;
}

uint32_t timer1::now()
{
	uint32_t t;		
	//cli();
	t = millis;
	//sei();
	return t;
}

void timer1::off()
{
	TCCR1A = 0;
	TCCR1B = 0;
}

void timer1::Overflow_interrupt_handler()
{
	TIFR1 &= ~(1 << TOV1);
}

void timer1::CompareMatchA_interrupt_handler()
{
	if(isOn)
	{
		//every 1024us ocurr an interrupt
		millis += 1;	// ms update
		fract += 3;		// fract is the error accumulate
		if (fract >= 125) //if error reach 125 it mean the error reach 1 ms
		{
			fract -= 125;
			millis += 1;
		}
	}
	
	TIFR1 &= ~(1 << OCF1A);
}