/*
 * constantes.h
 *
 * Created: 19/12/2014 12:25:59
 *  Author: Reta
 */ 


#ifndef CONSTANTES_H_
#define CONSTANTES_H_

#define F_CPU		16000000UL
#define BAUD_RATE	57600U
#define I2c_Clock	100000U

#define PI			3.1415926535897932384626433832795
#define HALF_PI		1.5707963267948966192313216916398
#define TWO_PI		6.283185307179586476925286766559
#define DEG_TO_RAD	0.017453292519943295769236907684886
#define RAD_TO_DEG	57.295779513082320876798154814105

#define Enc_Resolution	344
#define Enc_Gear_Ratio	34	//45
#define RADIO			0.0315	//metros 6.3/100/2

#define Conv_m_Seg	2*PI*RADIO*1000/(Enc_Resolution*Enc_Gear_Ratio)
#define Conv_rpm	60*1000/(Enc_Gear_Ratio*Enc_Resolution)

// Encoder 1 is on the Right - derecha
#define Ddr_Enc1	&DDRD
#define Port_Enc1	&PORTD
#define In_Enc1		&PIND
#define Imsk_Enc1	&PCMSK2
#define Pin_Enc1A	6	
#define Pin_Enc1B	7	

// Encoder 2 is on the Left - izquierda
#define Ddr_Enc2	&DDRB
#define Port_Enc2	&PORTB
#define In_Enc2		&PINB
#define Imsk_Enc2	&PCMSK0
#define Pin_Enc2A	1
#define Pin_Enc2B	2	

#define Ddr_M1		&DDRB
#define Port_M1		&PORTB
#define Pin_A1		4
#define Pin_B1		5
#define En_M1		3	//OC2A

#define Ddr_M2		&DDRD
#define Port_M2		&PORTD
#define Pin_A2		4
#define Pin_B2		3
#define En_M2		5	//OC0B

#define Ddr_Cam		&DDRC
#define Port_Cam	&PORTC
#define Pin_Cam		1

#define Ddr_Wifly	&DDRD
#define Port_Wifly	&PORTD
#define Pin_Wifly	2

#define Ddr_Led		&DDRC
#define Port_Led	&PORTC
#define Pin_Led		3

#define Pin_Adc		0

#define MIN(a,b)	((a<b)?(a):(b))
#define MAX(a,b)	((a>b)?(a):(b))
#define ABS(x)		((x>0)?(x):(-x))

// maximum value that can be held
// by unsigned data types (8,16,32bits)
#define MAX_U08	255
#define MAX_U16	65535
#define MAX_U32	4294967295

// maximum values that can be held
// by signed data types (8,16,32bits)
#define MIN_S08	-128
#define MAX_S08	127
#define MIN_S16	-32768
#define MAX_S16	32767
#define MIN_S32	-2147483648
#define MAX_S32	2147483647

#endif /* CONSTANTES_H_ */