/*
 * pid.h
 *
 * Created: 10/04/2015 14:31:23
 *  Author: Reta
 */ 


#ifndef PID_H_
#define PID_H_

#include <stdint.h> // needed for uint_8

class pid
{
	public:
		double E;			// result of pid
	
	private:		
		
		double	 errores[3];	// errores			
		double * P;			// Proportional Constant
		double * D;			// Derivation Constant
		double * I;			// Integration Constant
		double * Ref;		// Reference
		
	public:
				pid(double * ref, double * kp, double * kd, double * ki);
		void	restart_errors();
		void	calc(double val, uint32_t time);
};
#endif /* PID_H_ */