/*
 * gpio.h
 *
 * Created: 09/12/2014 17:27:23
 *  Author: Reta
 */ 


#ifndef __GPIO_H_INCLUDED__
#define __GPIO_H_INCLUDED__

#include <avr/io.h>
#include <stdint.h> // needed for uint_8
#include <stdbool.h> //needed for boolean type

class gpio
{	
	private:
		volatile uint8_t * ddr;					// Data Direccion Register
		volatile uint8_t * port;				// Port Data Register
		volatile uint8_t * port_in;				// Port In Data
		volatile uint8_t * imsk;				// Mask Register
		int8_t			   pin;					// Pin selected
		bool			   isIntEnable;			// 
	
	public:
			 gpio();
			 gpio(volatile uint8_t *DDR, volatile uint8_t *PORT, uint8_t PIN);
		void reset();
		void output();
		void input(volatile uint8_t * IN, bool pull_up);
		void input(volatile uint8_t * IN, bool pull_up,  volatile uint8_t * IMSK);
		void set_interrupt_enable(bool enabled);		
		bool read();
		void high();
		void low();
		void toggle();	
};

#endif /* GPIO_H_ */
