/*
 * pwm.cpp
 *
 * Created: 10/12/2014 15:45:53
 *  Author: Reta
 */ 

#include "pwm.h"

void pwm0::timer_setup()
{
	// timer 0
	//DDRD |= (1 << DDD6);		// OC0A, pin PD6 is output
	DDRD |= (1 << DDD5);		// OC0B, pin PD5 is output
	
	//OCR0A = 0;
	OCR0B = 0;					// duty igual a 0
	
	//TCCR0A |= (1 << COM0A1);	// set none-inverting mode an enable channel A
	TCCR0A |= (1 << COM0B1);	// set none-inverting mode and enable channel B
	
	TCCR0A |= (1 << WGM00);		// set PWM Phase Corrected mode TOP 0xFF=255
	//TCCR0B |= (1 << CS02);		// set prescaler to 256 and starts PWM, frecuencia del PWM es de 122 KHZ
	TCCR0B |= (1 << CS02) | (1 << CS00); // set prescaler to 1024 and starts PWM, frecuencia del PWM es de 30.6 KHZ
	
}

void pwm0::timer_off()
{
	OCR0A = 0;
	OCR0B = 0;
	TCCR0A = 0;
	TCCR0B = 0;
}

//void pwm0::set_duty_A(uint8_t duty)
//{
	//OCR0A = duty;
//}

void pwm0::set_duty(uint8_t duty)
{
	OCR0B = duty;
}

void pwm1::timer_setup(uint16_t duty)
{
	DDRB |= (1 << DDB1); //OC1A, pin PB1 es output
	DDRB |= (1 << DDB2); //OC1B, pin PB2 es output
	
	ICR1 = 20000;		 // set TOP of 20000
	
	OCR1A = duty;
	OCR1B = duty;
	
	// set PWM in "duty" cycle @ 16bit
	TCCR1A |= (1 << COM1A1); // set none-inverting mode and enable Channel A
	TCCR1A |= (1 << COM1B1); // set none-inverting mode and enable Channel B

	TCCR1B |= (1 << WGM13);
	// set Phase and Frequency Corrected mode using ICR1 as TOP
	TCCR1B |= (1 << CS11);
	// START the timer with 8 prescaler, 50 Hz
}

void pwm1::timer_off()
{
	ICR1 = 0;
	OCR1A = 0;
	OCR1B = 0;
	TCCR1A = 0;
	TCCR1B = 0;
}

void pwm1::set_duty_A(uint16_t duty)
{
	OCR1A = duty;
}

void pwm1::set_duty_B(uint16_t duty)
{
	OCR1B = duty;
}

void pwm2::timer_setup()
{
	// timer 2
	DDRB |= (1 << DDB3);		//OC2A, pin pB3 is output
	//DDRD |= (1 << DDD3);		//OC2B, pin pD3 is output
	
	OCR2A = 0;
	//OCR2B = 0;
	
	TCCR2A |= (1 << COM2A1);	// set none-inverting mode and enable channel A
	//TCCR2A |= (1 << COM2B1);	// set none-inverting mode and enable channel B
	
	TCCR2A |= (1 << WGM20);		// set PWM Phase Corrected mode TOP 0xFF=255
	//TCCR2B |= (1 << CS22);		// set prescaler to 256 and starts PWM, frecuencia del PWM es de 122 HZ
	TCCR2B |= (1 << CS22) | (1 << CS20); // set prescaler to 1024 and starts PWM, frecuencia del PWM es de 30.6 KHZ
}

void pwm2::timer_off()
{
	OCR2A = 0;
	OCR2B = 0;
	TCCR2A = 0;
	TCCR2B = 0;
}

void pwm2::set_duty(uint8_t duty)
{
	OCR2A = duty;
}

//void pwm2::set_duty_B(uint8_t duty)
//{
	//OCR2B = duty;
//}