/*
 * test.cpp
 *
 * Created: 27/07/2015 10:31:33
 *  Author: Reta
 */ 

// Revisar cuando se coloca kd != 0 las indefiniciones del pid (nan o inf) 
// Revisar los valores de Kd al eliminar el feedback de los valores (strings)
// ver comando show rssi para ver si se puede ocupar como indicar de distancia
// implementar un "alive" para el auto para saber su situacion
// Revisar el uso del metodo cli()
// revisar el correcto include de las librerias

#include "Clases/constantes.h"
#include "Clases/init.h"

#include "Clases/Adc/adc.h"
#include "Clases/Gpio/gpio.h"
#include "Clases/Gpio/Gpio_Interrupt.h"
//#include "Clases/I2c/i2cdev.h"
//#include "Clases/Pwm/pwm.h"
#include "Clases/Timer/timer.h"
#include "Clases/Uart/uart.h"

#include "Clases/Control/car.h"
#include "Clases/Control/pid.h"
#include "Clases/Sensores/Encoder/encoder.h"

gpio Cam_En(Ddr_Cam, Port_Cam, Pin_Cam);
gpio Wifly_En(Ddr_Wifly, Port_Wifly, Pin_Wifly);
gpio Led(Ddr_Led, Port_Led, Pin_Led);

double alpha;

encoder Enc2(&alpha, Ddr_Enc2, Port_Enc2, In_Enc2, Imsk_Enc2, Pin_Enc2A, Pin_Enc2B);
encoder Enc1(&alpha, Ddr_Enc1, Port_Enc1, In_Enc1, Imsk_Enc1, Pin_Enc1A, Pin_Enc1B);

uint16_t voltaje;

int16_t Right_Speed;
int16_t Left_Speed;

double Ref_Straight;
double Ref_Turn;

double Kd_Straight;
double Kd_Turn;

double Ref_Vel;
double Kp;
double Ki;
double Kd;
pid Right_pid(&Ref_Vel, &Kp, &Kd, &Ki);
pid Left_pid(&Ref_Vel, &Kp, &Kd, &Ki);

double Ref_master;
double Kp_master;
double Ki_master;
double Kd_master;
pid Master_pid(&Ref_master, &Kp_master, &Kd_master, &Ki_master);

bool IsInit;
bool IsMoving;
bool IsTurn;

char Begin_string[] = "Velr,Pidr,Pwmr,Tr,Vell,Pidl,Pwml,Tl,Merr";
char Right_string[40] = {};
char Left_string[40] = {};

uint8_t IsStringReady;

void wait_wifly()
{
	_delay_ms(5000);
	
	do 
	{
		Uart::Rx = Uart::Receive();
		
	} while (Uart::Rx != 'h');	
}

void check_MCU(void)
{
	if(MCUSR & (1<<PORF ))
	Uart::Send_string("Power-on reset!\n");
	if(MCUSR & (1<<EXTRF))
	Uart::Send_string("External reset!\n");
	if(MCUSR & (1<<BORF ))
	Uart::Send_string("Brownout reset!\n");
	if(MCUSR & (1<<WDRF ))
	Uart::Send_string("Watchdog reset!\n");
	//if(MCUCSR & (1<<JTRF )) Serial.Send_String("JTAG reset!\n");
	MCUSR = 0;
}

void var_init()
{		
	voltaje = 0;
	
	Cam_En.output();
	Wifly_En.output();
	Led.output();
	
	//Cam_En.low();
	Cam_En.high();
	Wifly_En.low();		//logica invertida -> high(off) - low(on)
	Led.low();
	
	alpha = 0.7;
	
	Right_Speed = 0;
	Left_Speed = 0;	
	
	Ref_Straight = 200;
	Ref_Turn = 75;
	
	Kd_Straight = 0.001f;
	Kd_Turn = 0.05f;
	
	Ref_Vel = 0; //rpm
	Kp = 0.1f;
	Ki = 0.01f;
	Kd = 0.0f;
	
	Ref_master = 0;
	Kp_master = 0.1f;
	Ki_master = 0.01f;
	Kd_master = 0.005f;
		
	IsInit = false;
	IsMoving = false;
	IsTurn = false;
		
	IsStringReady= 0;
}

int main(void)
{	
	cli();
	var_init();
	Uart::setup(BAUD_RATE, F_CPU);	
	
	wait_wifly();
	
	check_MCU();
	
	sprintf(Uart::Tx, "Cpu Clock: %lu MHz \n", F_CPU/1000000);
	Uart::Send_string(Uart::Tx);
	sprintf(Uart::Tx, "Serial BaudRate: %u \n", BAUD_RATE);
	Uart::Send_string(Uart::Tx);
	
	sprintf(Uart::Tx, "Timer Clock: %lu KHz\n", F_CPU/64/1000);
	Uart::Send_string(Uart::Tx);
	sprintf(Uart::Tx, "Timer Compare Match A : %.3f Hz - %.3f ms\n", F_CPU/(double)(64*256) , (64*256)/(double)F_CPU*1000);
	Uart::Send_string(Uart::Tx);
	
	Uart::Send_string("Encoders:\n");
	sprintf(Uart::Tx, "Resolution is %u, with a Gear Ratio of %f\n", Enc_Resolution, Enc_Gear_Ratio);
	Uart::Send_string(Uart::Tx);
	sprintf(Uart::Tx, "%f signal is equal to a 1 revolution\n", Enc_Resolution*Enc_Gear_Ratio);
	Uart::Send_string(Uart::Tx);
	sprintf(Uart::Tx, "Each signal means %f degrees/signal\n", 360/(double)(Enc_Resolution*Enc_Gear_Ratio));
	Uart::Send_string(Uart::Tx);
	
	Enc1.Set_enable(true);
	Enc2.Set_enable(true);
	
	timer1::setup();
	
	adc::setup(true, Pin_Adc);
	
	Uart::Send_string("Loop Begin\n");

	sei();
		
    while(1)
    {
        _delay_us(1);
		
#pragma region Reception		
						
		if(Uart::IsRx)
		{					
			if(IsInit)
			{			
				if(Uart::Rx == 'W' || Uart::Rx == 'S')
				{	
					timer1::start();
					Ref_Vel = Ref_Straight;
					Kd = Kd_Straight;
					car::direction(Uart::Rx);
					IsMoving = true;
					sprintf(Uart::Tx, "Ref - Kp - Kd - Ki: %.4f - %.4f - %.4f - %.4f\n", Ref_Vel, Kp, Kd, Ki);
					Uart::Send_string(Uart::Tx);
					sprintf(Uart::Tx, "Ref_Master - Kp_Master - Kd_Master - Ki_Master: %.4f - %.4f - %.4f - %.4f\n", Ref_master, Kp_master, Kd_master, Ki_master);
					Uart::Send_string(Uart::Tx);
					sprintf(Uart::Tx,"%s\n", Begin_string);
					Uart::Send_string(Uart::Tx);
					IsTurn = false;
				}
				
				else if(Uart::Rx == 'A' || Uart::Rx == 'D')
				{
					timer1::start();
					Ref_Vel = Ref_Turn;
					Kd = Kd_Turn;
					car::direction(Uart::Rx);
					IsTurn = true;
					sprintf(Uart::Tx, "Ref - Kp - Kd - Ki: %.4f - %.4f - %.4f - %.4f\n", Ref_Vel, Kp, Kd, Ki);
					Uart::Send_string(Uart::Tx);
					sprintf(Uart::Tx,"%s\n", Begin_string);
					Uart::Send_string(Uart::Tx);
					IsMoving = false;
				}
				
				else if(Uart::Rx == 'G')
				{	
					timer1::stop();
					Ref_Vel = 0;
					car::direction(Uart::Rx);
					IsMoving = false;
					IsTurn = false;
					
					Enc1.reset();
					Enc2.reset();
					
					Right_pid.restart_errors();
					Right_Speed = 0;
					
					Left_pid.restart_errors();
					Left_Speed = 0;
				}
			
				else if (Uart::Rx == 'm')
				{
					//Uart::Send_string("Starting Adc\n");
					adc::start();
				}
				
				else if (Uart::Rx == 'l')
				{
					Uart::Send_string("Live\n");					
				}
			
				else if (Uart::Rx == 'o')
				{
					Uart::Send_string("Stopping\n");
					timer1::stop();
					//Cam_En.low();
					//Wifly_En.high();	//logica invertida -> high(off) - low(on)
					car::off();
					IsInit = false;
					Gpio_Interrupt::Int_PortB_enable(false);				// for Enc2
					Gpio_Interrupt::Int_PortD_enable(false);				// for Enc1
					IsMoving = false;
					IsTurn = false;
					
					Enc1.reset();
					Enc2.reset();
					
					Right_pid.restart_errors();
					Right_Speed = 0;
					
					Left_pid.restart_errors();
					Left_Speed = 0;
					
					Led.low();
				}			
				else
				{
					sprintf(Uart::Tx, "The %c char is not in the list\n", Uart::Rx);
					Uart::Send_string(Uart::Tx);
				}
			}
		
			else
			{
				if (Uart::Rx == 's')
				{	
					//Cam_En.high();
					IsInit = true;
					Uart::Send_string("Starting\n");					
					//Wifly_En.low();	//logica invertida -> high(off) - low(on)
					car::setup();
					Gpio_Interrupt::Int_PortB_enable(true);				// for Enc2
					Gpio_Interrupt::Int_PortD_enable(true);				// for Enc1
					Led.high();
					IsMoving = false;				
				}
			
				else if(Uart::Rx == 'p')
				{
					Uart::Rx = Uart::Receive();
					
					if (Uart::Rx == 'p')
					{
						Kp = Uart::Receive_float_until('p');
						sprintf(Uart::Tx, "Kp: %.4f\n", Kp);
						Uart::Send_string(Uart::Tx);
					} 
					else if(Uart::Rx == 'm')
					{
						Kp_master = Uart::Receive_float_until('p');
						sprintf(Uart::Tx, "Kp_master: %.4f\n", Kp_master);
						Uart::Send_string(Uart::Tx);
					}
					else
					{
						sprintf(Uart::Tx, "The %c char is not in the list\n", Uart::Rx);
						Uart::Send_string(Uart::Tx);
					}
					
				}
			
				else if(Uart::Rx == 'i')
				{
					Uart::Rx = Uart::Receive();
					
					if (Uart::Rx == 'i')
					{
						Ki = Uart::Receive_float_until('p');
						sprintf(Uart::Tx, "Ki: %.4f\n", Ki);
						Uart::Send_string(Uart::Tx);;
					} 
					else if(Uart::Rx == 'm')
					{
						Ki_master = Uart::Receive_float_until('p');
						sprintf(Uart::Tx, "Ki_master: %.4f\n", Ki_master);
						Uart::Send_string(Uart::Tx);;
					}
					else
					{
						sprintf(Uart::Tx, "The %c char is not in the list\n", Uart::Rx);
						Uart::Send_string(Uart::Tx);
					}			
				}
			
				else if(Uart::Rx == 'd')
				{	
					Uart::Rx = Uart::Receive();
					
					if (Uart::Rx == 's')
					{
						Kd_Straight = Uart::Receive_float_until('p');
						sprintf(Uart::Tx, "Kd_Straight: %.4f\n", Kd_Straight);
						Uart::Send_string(Uart::Tx);
					} 
					else if (Uart::Rx == 't')
					{
						Kd_Turn = Uart::Receive_float_until('p');
						sprintf(Uart::Tx, "Kd_Turn: %.4f\n", Kd_Turn);
						Uart::Send_string(Uart::Tx);
					}
					else if (Uart::Rx == 'm')
					{
						Kd_master = Uart::Receive_float_until('p');
						sprintf(Uart::Tx, "Kd_master: %.4f\n", Kd_master);
						Uart::Send_string(Uart::Tx);
					}
					else
					{
						sprintf(Uart::Tx, "The %c char is not in the list\n", Uart::Rx);
						Uart::Send_string(Uart::Tx);
					}					
				}
				
				else if(Uart::Rx == 'r')
				{	
					Uart::Rx = Uart::Receive();
								
					if (Uart::Rx == 's')
					{
						Ref_Straight = Uart::Receive_float_until('p');
						sprintf(Uart::Tx, "Ref_Straight: %.4f\n", Ref_Straight);
						Uart::Send_string(Uart::Tx);
					}
					else if (Uart::Rx == 't')
					{
						Ref_Turn = Uart::Receive_float_until('p');
						sprintf(Uart::Tx, "Ref_Turn: %.4f\n", Ref_Turn);
						Uart::Send_string(Uart::Tx);
					}
					else
					{
						sprintf(Uart::Tx, "The %c char is not in the list\n", Uart::Rx);
						Uart::Send_string(Uart::Tx);
					}
				}
				
				else if(Uart::Rx == 'a')
				{
					alpha = Uart::Receive_float_until('p');
					sprintf(Uart::Tx, "alpha: %.4f\n", alpha);
					Uart::Send_string(Uart::Tx);
				}
			
				else
				{
					sprintf(Uart::Tx, "The %c char is not in the list\n", Uart::Rx);
					Uart::Send_string(Uart::Tx);
				}
			}
		
			Uart::reset_variable();
		}
		
#pragma endregion Reception

		if(IsInit)
		{
			if(IsMoving  || IsTurn)
			{
				Enc1.update();
				Enc2.update();
				
				Enc1.cal_vel();
				Enc2.cal_vel();
				
				if(IsMoving)
				{
					Master_pid.calc(Enc1.new_vel - Enc2.new_vel, Enc1.diff_time);
					
					Right_pid.calc(Enc1.new_vel - Master_pid.E, Enc1.diff_time);
					Left_pid.calc(Enc2.new_vel + Master_pid.E, Enc2.diff_time);
				}
				
				else
				{
					Right_pid.calc(Enc1.new_vel, Enc1.diff_time);
					Left_pid.calc(Enc2.new_vel, Enc2.diff_time);
				}
				
				
				Right_Speed += Right_pid.E;
				if (Right_Speed > 255)		Right_Speed = 255;
				else if (Right_Speed < 0)	Right_Speed = 0;
				
				Left_Speed += Left_pid.E;
				if (Left_Speed > 255)		Left_Speed = 255;
				else if (Left_Speed < 0)	Left_Speed = 0;
				
				car::en_right(uint8_t(Right_Speed & 0xff));
				car::en_left(uint8_t(Left_Speed & 0xff));				
				
				//sprintf(Right_string, "%f,%f,%i,%lu,%lu", Enc1.new_vel, Right_pid.E, uint8_t(Right_Speed & 0xff), Enc1.diff_time, Enc1.diff_count);
				//sprintf(Left_string,"%f,%f,%i,%lu,%lu", Enc2.new_vel, Left_pid.E, uint8_t(Left_Speed & 0xff), Enc2.diff_time, Enc2.diff_count);
				//sprintf(Uart::Tx,"%s,%s,%f\n", Right_string, Left_string, Enc1.new_vel - Enc2.new_vel);
				
				sprintf(Right_string, "%f,%i,%lu,%lu", Enc1.new_vel,uint8_t(Right_Speed & 0xff), Enc1.diff_time, Enc1.diff_count);
				sprintf(Left_string,"%f,%i,%lu,%lu", Enc2.new_vel, uint8_t(Left_Speed & 0xff), Enc2.diff_time, Enc2.diff_count);
				sprintf(Uart::Tx,"%s,%s,%f\n", Right_string, Left_string, Enc1.new_vel - Enc2.new_vel);
				
				Uart::Send_string(Uart::Tx);
				//_delay_ms(1);
			}
		}
	}		
}

ISR(BADISR_vect)
{
	Uart::Send_string("interrupt not handle\n");
}

ISR (ADC_vect)
{
	//Uart::Send_string("Adc Interrupt\n");
	adc::Interrupt_Handler(&voltaje);
	//Uart::Send_Word(voltaje); // revisar que se envie los datos por wifly (posible falta de "\n")
	sprintf(Uart::Tx, "voltage is: %.4f\n", voltaje*(double)5/(double)1024);
	Uart::Send_string(Uart::Tx);
}

ISR (USART_RX_vect)
{
	//Uart::Send_string("Usart Rx Interrupt\n");
	Uart::Rx_Interrupt_Handler();	
}

ISR (TIMER1_COMPA_vect)
{
	//Serial.Send_string("Timer 1 B COmpare\n");
	timer1::CompareMatchA_interrupt_handler();
	//Led.toggle();
}

ISR(PCINT0_vect)
{
	//Uart::Send_string("interrupt on port B\n");
	Enc2.Interrupt_Count_Handler();
	Gpio_Interrupt::Int_PortB_ClearFlag();
}

ISR(PCINT2_vect)
{
	//Uart::Send_string("interrupt on port D\n");
	Enc1.Interrupt_Count_Handler();
	Gpio_Interrupt::Int_PortD_ClearFlag();
}
