﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Interfaz_v1.Class.Events
{
    public delegate void NewVideoFrameEventHandler(NewVideoFrameEventArgs e);
    public delegate void NewAudioFrameEventHandler(NewAudioFrameEventArgs e);
    public delegate void BoolEventHandler(BoolEventArgs e);
    public delegate void BatteryEventHandler(BatteryEventArgs e);

    public class NewVideoFrameEventArgs : EventArgs
    {
        public Bitmap frame;

        public NewVideoFrameEventArgs(Bitmap _frame)
        {
            frame = _frame;
        }
    }

    public class NewAudioFrameEventArgs : EventArgs
    {
        public byte[] frame;

        public NewAudioFrameEventArgs(byte[] _frame)
        {
            frame = _frame;
        }
    }

    public class BoolEventArgs : EventArgs
    {
        public bool Bool;

        public BoolEventArgs(bool _bool)
        {
            Bool = _bool;
        }
    }

    public class BatteryEventArgs : EventArgs
    {
        public string val;

        public BatteryEventArgs(string s)
        {
            val = s;
        }
    }
}
