﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Drawing;
using System.Linq;
using System.Linq.Expressions;
using System.Reflection;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Interfaz_v1
{
    class Init : Form
    {
        #region Def_Graph_Variables

        private Size size;

        private PictureBox wifly_box;
        private PictureBox cam_box;
        private Label wifly_connect_label;
        private Label cam_connect_label;

        Image progress_gift;
        Image error_icon;
        Image check_icon;

        int x_wifi_label;
        int y_wifi_label;

        int x_cam_label;
        int y_cam_label;

        string wifly_text;
        string cam_text;        

        Font labels_font;

        #endregion

        private Principal first_form;

        Thread Connection_Thread;

        public Init(Principal p, Size s)
        {
            size = s;
            progress_gift = Image.FromFile("Images/circle_bar_progress.gif");
            error_icon = Image.FromFile("Images/red.png");
            check_icon = Image.FromFile("Images/green.png");

            first_form = p;

            InitializeComponent();       
        }

        private System.ComponentModel.IContainer components = null;

        protected override void Dispose(bool disposing)
        {
            if (disposing && (components != null))
            {
                components.Dispose();
            }
            base.Dispose(disposing);
        }

        private void InitializeComponent()
        {
            #region Init_Variables

            x_wifi_label = 25;
            y_wifi_label = 25;

            x_cam_label = 25;
            y_cam_label = 75;

            wifly_text = "Wifly... "; 
            cam_text = "Camera... ";

            labels_font = new Font("Comic Sans MS", 18.0F, FontStyle.Bold);

            #endregion

            #region Init_Controls

            components = new System.ComponentModel.Container();
            wifly_box = new PictureBox();
            cam_box = new PictureBox();
            cam_connect_label = new Label();
            wifly_connect_label = new Label();
            this.SuspendLayout();

            // wifly_box
            wifly_box.Name = "progress_box";
            wifly_box.SizeMode = PictureBoxSizeMode.StretchImage;
            wifly_box.BackColor = Color.Transparent;
            wifly_box.Location = new Point(0, 0);
            //wifly_box.Size = new Size(25, 25);
            wifly_box.Image = progress_gift;

            // wifly_box
            cam_box.Name = "cam_box";
            cam_box.SizeMode = PictureBoxSizeMode.StretchImage;
            cam_box.BackColor = Color.Transparent;
            cam_box.Location = new Point(0, 0);
            //cam_box.Size = new Size(25, 25);
            cam_box.Image = progress_gift;
            cam_box.Visible = false;

            // wifly_connect_label
            wifly_connect_label.Font = labels_font;
            wifly_connect_label.ForeColor = Color.Black;
            wifly_connect_label.AutoSize = true;
            wifly_connect_label.Location = new System.Drawing.Point(x_wifi_label, y_wifi_label);
            wifly_connect_label.Name = "wifly_connect_label";
            wifly_connect_label.Text = wifly_text;

            // cam_connect_label
            cam_connect_label.Font = labels_font;
            cam_connect_label.ForeColor = Color.Black;
            cam_connect_label.AutoSize = true;
            cam_connect_label.Location = new System.Drawing.Point(x_cam_label, y_cam_label);
            cam_connect_label.Name = "cam_connect_label";
            cam_connect_label.Text = cam_text;
            cam_connect_label.Visible = false;                    

            // Init
            //this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
            //this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;            
            this.StartPosition = FormStartPosition.CenterScreen;
            this.WindowState = FormWindowState.Normal;
            this.BackColor = SystemColors.Control;
            this.ClientSize = size;
            this.Controls.Add(this.wifly_box);
            this.Controls.Add(this.cam_box);
            this.Controls.Add(this.cam_connect_label);
            this.Controls.Add(this.wifly_connect_label);
            this.Name = "Init";
            this.Text = "Loading";
            this.Load += new EventHandler(Init_Load);
            this.Activated += new EventHandler(Init_Activated);
            this.FormClosing += new FormClosingEventHandler(Init_FormClosing);
            this.ResumeLayout(false);
            this.PerformLayout();

            #endregion
        }

        private void Init_Load(object sender, EventArgs e)
        {
            
        }

        private void Init_Activated(object sender, EventArgs e)
        {
            wifly_connect_label.Text = wifly_text + "Connecting";

            wifly_box.Location = new Point(Convert.ToInt32(wifly_connect_label.Width * 1.15), y_wifi_label);
            wifly_box.Size = new Size(wifly_connect_label.Height, wifly_connect_label.Height);

            Connection_Thread = new Thread(new ThreadStart(first_form.Car.Search));
            Connection_Thread.Start();
        }

        private void Init_FormClosing(object sender, FormClosingEventArgs e)
        {

        }

        public void wifly_Founding_End(bool isConnect)
        {
            if(isConnect)
            {
                Debug.WriteLine("Wifly found");
                set_prop(wifly_connect_label, "Text", wifly_text + "Founded");
                set_prop(wifly_box, "Image", check_icon);

                first_form.Car.Connect();
            }
            else
            {
                Debug.WriteLine("Wifly No found");
                wifly_Connection_End(false);
            }
        }

        public void wifly_Connection_End(bool isConnect)
        {
            if (isConnect)
            {
                Debug.WriteLine("Wifly Connected");
                set_prop(wifly_connect_label, "Text", wifly_text + "Connected");
                set_prop(wifly_box, "Image", check_icon);

                first_form.Car.Setup();
            }
            else
            {
                Debug.WriteLine("Wifly No Connected");
                set_prop(wifly_connect_label, "Text", wifly_text + "No Connected");
                set_prop(wifly_box, "Image", error_icon);
            }

            set_prop(wifly_box, "Location", new Point(Convert.ToInt32(wifly_connect_label.Width * 1.15), y_wifi_label));
            set_prop(wifly_box, "Size", new Size(wifly_connect_label.Height, wifly_connect_label.Height));


            set_prop(cam_connect_label, "Visible", true);
            set_prop(cam_connect_label, "Text", cam_text + "Connecting");

            set_prop(cam_box, "Location", new Point(Convert.ToInt32(cam_connect_label.Width * 1.15), y_cam_label));
            set_prop(cam_box, "Size", new Size(cam_connect_label.Height, cam_connect_label.Height));
            set_prop(cam_box, "Visible", true);

            first_form.Cam.Search();
        }

        public void Cam_Founding_End(bool isFound)
        {
            if (isFound)
            {
                Debug.WriteLine("Cam found");
                set_prop(cam_connect_label, "Text", cam_text + "Founded");

                first_form.Cam.Connect();                
            }
            else
            {
                Debug.WriteLine("Cam no found");
                set_prop(cam_connect_label, "Text", cam_text + "No Founded");
                set_prop(cam_box, "Image", error_icon);
            }            

            set_prop(cam_box, "Location", new Point(Convert.ToInt32(cam_connect_label.Width * 1.15), y_cam_label));
            set_prop(cam_box, "Size", new Size(cam_connect_label.Height, cam_connect_label.Height));                       
        }

        public void Cam_Connecting_End(bool isConnect)
        {
            if (isConnect)
            {
                Debug.WriteLine("Cam Connect");
                set_prop(cam_connect_label, "Text", cam_text + "Connected");
                set_prop(cam_box, "Image", check_icon);
            }
            else
            {
                Debug.WriteLine("Cam No Connect");
                set_prop(cam_connect_label, "Text", cam_text + "No Connected");
                set_prop(cam_box, "Image", error_icon);
            }

            set_prop(cam_box, "Location", new Point(Convert.ToInt32(cam_connect_label.Width * 1.15), y_cam_label));
            set_prop(cam_box, "Size", new Size(cam_connect_label.Height, cam_connect_label.Height));

            first_form.Cam.Setup();

            set_prop(this, "Close", null);
        } 

        delegate void SetPropCallback(object o, string property_name, object value);
        public void set_prop(object o, string property_name, object value)
        {
            #region Label

            if (o is Label)
            {
                var label = o as Label;

                if (label.InvokeRequired)
                {
                    SetPropCallback text_Callback = new SetPropCallback(set_prop);
                    this.Invoke(text_Callback, new object[] { label, property_name, value });
                }
                else
                {
                    if (property_name == "Text")
                    {
                        label.Text = value as string;
                    }
                    else if (property_name == "Visible")
                    {
                        label.Visible = (bool)value;
                    }
                }
            }

            #endregion

            #region PictureBox

            if (o is PictureBox)
            {
                var picture = o as PictureBox;

                if (picture.InvokeRequired)
                {
                    SetPropCallback text_Callback = new SetPropCallback(set_prop);
                    this.Invoke(text_Callback, new object[] { picture, property_name, value });
                }
                else
                {
                    if (property_name == "Location")
                    {
                        picture.Location = (Point)value;
                    }
                    else if (property_name == "Size")
                    {
                        picture.Size = (Size)value;
                    }
                    else if (property_name == "Image")
                    {
                        picture.Image = (Image)value;
                    }
                    else if (property_name == "Visible")
                    {
                        picture.Visible = (bool)value;
                    }
                }
            }

            #endregion

            #region Form

            if (o is Form)
            {
                var form = o as Form;

                if (form.InvokeRequired)
                {
                    SetPropCallback text_Callback = new SetPropCallback(set_prop);
                    this.Invoke(text_Callback, new object[] { form, property_name, value });
                }
                else
                {
                    if (property_name == "Close")
                    {
                        form.Close();
                    }

                }
            }

            #endregion

        }

    }
}
