﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

using EyeXFramework;
using Tobii.EyeX.Framework;
using System.Diagnostics;
using System.Threading;
using Foscam_Mpeg;
using Foscam_Mpeg.Events;
using Interfaz_v1.Class.Panel;


// Por Hacer:
//              * Interfaz de carga para setear y conectarse con wifly y camara (primera version lista)
//              * Hacer evento en clase camara para extraer la imagen de la camara (listo)
//              * Probar comunicacion con Wifly
//              * Probar comunicacion con Camara ip (listo)
//              * Revisar metodo Camara.Setup() que no se esta moviendo la camara
//              * Revisar cuando se cierra tempranamente ventana init  -> tira error
//              * Probar interacción entre tobbi, interfaz y dispositivo -> Problemas visuales entre los paneles y las actualizaciones de las imagenes de la camara (arreglado)
//              * Ver condicion de carrera al colocar imagen de la camara
//

namespace Interfaz_v1
{
    public class Principal : Form
    {
        private System.ComponentModel.IContainer components = null;

        #region Variables_Interfaz_Grafica

        Init LoadForm;
        Button Start_button;

        EyeXFramework.Forms.BehaviorMap MybehaviorMap;        

        PictureBox Video_box;
        PictureBox figAuto_box;
        PictureBox figCam_box;
        PictureBox figBat_box;

        MyPanel Up_panel;
        MyPanel Down_panel;
        MyPanel Right_panel;
        MyPanel Left_panel;

        Color green;
        Color red;        

        // Insertamos imagenes que se van a colocar sobre el video
        private Image figure_Auto;
        private Image figure_Cam;
        private static Image figure_Bat;

        Image auto_no_vanish;
        Image auto_vanish;

        Image cam_no_vanish;
        Image cam_vanish;

        Image battery_complete;
        Image battery_low;
        Image battery_critical;
       
        Rectangle ScreenBounds;

        // Posiciones y Dimensiones del panel superior e inferior
        int x_up;
        int y_up;

        int x_down;
        int y_down;

        int w_vert;
        int h_vert;

        // Posiciones y Dimensiones del panel derecho e izquierdo
        int x_right;
        int y_right;

        int x_left;
        int y_left;

        int w_hor;
        int h_hor;

        // Init, Posiciones y Dimensiones de las imagenes Auto, Cam y Bat

        double auto_scale;
        double cam_scale;
        double bat_scale;

        int x_auto;
        int y_auto;
        int w_auto;
        int h_auto;

        int x_cam;
        int y_cam;
        int w_cam;
        int h_cam;

        int x_bat;
        int y_bat;
        int w_bat;
        int h_bat;

        //Dimension y Posicion de Start_button
        int w_button;
        int h_button;
        int x_button;
        int y_button;
        
        //Dimension de Load_Form
        Size Size_Load_Form;

        #endregion

        bool Mode;
        bool Cam_Mode = true;
        bool Car_Mode = false;

        Camera Cam;

        Wifly Car;

        // Timer necesario paraa generar el request para la bateria
        System.Windows.Forms.Timer Request_timer;

        public Principal()
        {   
            InitializeComponent();

            Mode = Car_Mode;

            Cam = new Camera();
            Cam.FoundEvent += Cam_FoundEvent;
            Cam.ConnectEvent += Cam_ConnectEvent;
            Cam.VideoFrame += Cam_VideoFrame;
            
            Car = new Wifly();
            Car.ConnectionEvent += wifly_ConnectionEvent;

            LoadForm = new Init(ref Cam, ref Car, Size_Load_Form);                       

            Program.EyeXHost.Connect(MybehaviorMap);

            MybehaviorMap.Add(Up_panel, new GazeAwareBehavior(OnGazeMove) { DelayMilliseconds = 250 });
            MybehaviorMap.Add(Down_panel, new GazeAwareBehavior(OnGazeMove) { DelayMilliseconds = 250 });
            MybehaviorMap.Add(Right_panel, new GazeAwareBehavior(OnGazeMove) { DelayMilliseconds = 250 });
            MybehaviorMap.Add(Left_panel, new GazeAwareBehavior(OnGazeMove) { DelayMilliseconds = 250 });

            MybehaviorMap.Add(figAuto_box, new GazeAwareBehavior(OnGazeMode) { DelayMilliseconds = 250 });
            MybehaviorMap.Add(figCam_box, new GazeAwareBehavior(OnGazeMode) { DelayMilliseconds = 250 });
        }

        protected override void Dispose(bool disposing)
        {
            if (disposing && (components != null))
            {
                components.Dispose();
            }
            base.Dispose(disposing);
        }

        private void InitializeComponent()
        {
            #region Init_Variables

            green = Color.FromArgb(96, 92, 245, 61);
            red = Color.FromArgb(96, 250, 45, 98);

            ScreenBounds = Screen.FromControl(this).Bounds;

            Size_Load_Form = new Size((int)(0.25 * ScreenBounds.Width), (int)(0.20 * ScreenBounds.Height));

            // Posiciones y Dimensiones del panel superior e inferior
            x_up = (int)(0.30 * ScreenBounds.Width);
            y_up = (int)(0.05 * ScreenBounds.Height);

            x_down = (int)(0.30 * ScreenBounds.Width);
            y_down = (int)(0.80 * ScreenBounds.Height);

            w_vert = (int)(0.40 * ScreenBounds.Width);
            h_vert = (int)(0.15 * ScreenBounds.Height);

            // Posiciones y Dimensiones del panel derecho e izquierdo
            x_right = (int)(0.85 * ScreenBounds.Width);
            y_right = (int)(0.30 * ScreenBounds.Height);

            x_left = (int)(0.05 * ScreenBounds.Width);
            y_left = (int)(0.30 * ScreenBounds.Height);

            w_hor = (int)(0.10 * ScreenBounds.Width);
            h_hor = (int)(0.40 * ScreenBounds.Height);

            // Init, Posiciones y Dimensiones de las imagenes Auto, Cam y Bat

            auto_no_vanish = Image.FromFile("Images/car.png");
            auto_vanish = Image.FromFile("Images/car2.png");

            cam_no_vanish = Image.FromFile("Images/cam.png");
            cam_vanish = Image.FromFile("Images/cam3.png");

            battery_complete = Image.FromFile("Images/battery_complete3.png");
            battery_low = Image.FromFile("Images/battery_low3.png");
            battery_critical = Image.FromFile("Images/battery_critical3.png");

            figure_Auto = auto_no_vanish;
            figure_Cam = cam_vanish;
            figure_Bat = battery_low;

            auto_scale = (double)figure_Auto.Height / (double)figure_Auto.Width;
            cam_scale = (double)figure_Cam.Height / (double)figure_Cam.Width;
            bat_scale = (double)figure_Bat.Height / (double)figure_Bat.Width;

            x_auto = (int)(0.015 * ScreenBounds.Width);
            y_auto = (int)(0.73 * ScreenBounds.Height);
            w_auto = (int)(0.15 * ScreenBounds.Width);
            h_auto = (int)(auto_scale * 0.15 * ScreenBounds.Width);

            x_cam = (int)(0.825 * ScreenBounds.Width);
            y_cam = (int)(0.72 * ScreenBounds.Height);
            w_cam = (int)(0.12 * ScreenBounds.Width);
            h_cam = (int)(cam_scale * 0.12 * ScreenBounds.Width);

            x_bat = (int)(0.05 * ScreenBounds.Width);
            y_bat = (int)(0.05 * ScreenBounds.Height);
            w_bat = (int)(0.075 * ScreenBounds.Width);
            h_bat = (int)(bat_scale * 0.075 * ScreenBounds.Width);

            //Dimension y Posicion de Start_button
            w_button = (int)(0.20 * ScreenBounds.Width);
            h_button = (int)(0.20 * ScreenBounds.Height);
            x_button = (int)(0.5 * ScreenBounds.Width - w_button / 2);
            y_button = (int)(0.5 * ScreenBounds.Height - h_button / 2);

            #endregion 

            #region Init_Controls

            components = new Container();
            MybehaviorMap = new EyeXFramework.Forms.BehaviorMap(components);
            Request_timer = new System.Windows.Forms.Timer(components);  
            Up_panel = new MyPanel();
            Down_panel = new MyPanel();
            Right_panel = new MyPanel();
            Left_panel = new MyPanel();
            figAuto_box = new PictureBox();
            figCam_box = new PictureBox();
            figBat_box = new PictureBox();
            Start_button = new Button();
            Video_box = new PictureBox();
            ((System.ComponentModel.ISupportInitialize)(Video_box)).BeginInit();
            this.SuspendLayout();

            //Init Request_timer
            Request_timer.Interval = 20000;
            Request_timer.Tick += new EventHandler(Bateria_Request);

            //Init Panel Up_panel Properties
            Up_panel.Name = "Up_panel";
            Up_panel.BackColor = green;
            Up_panel.Location = new Point(x_up, y_up);
            Up_panel.Size = new Size(w_vert, h_vert);

            //Init Panel Up_panel Properties
            Down_panel.Name = "Down_panel";
            Down_panel.BackColor = green;
            Down_panel.Location = new Point(x_down, y_down);
            Down_panel.Size = new Size(w_vert, h_vert);

            //Init Panel Up_panel Properties
            Right_panel.Name = "Right_panel";
            Right_panel.BackColor = green;
            Right_panel.Location = new Point(x_right, y_right);
            Right_panel.Size = new Size(w_hor, h_hor);

            //Init Panel Up_panel Properties
            Left_panel.Name = "Left_panel";
            Left_panel.BackColor = green;
            Left_panel.Location = new Point(x_left, y_left);
            Left_panel.Size = new Size(w_hor, h_hor);

            //Init PictureBox figAuto_box Properties
            figAuto_box.Name = "figAuto_box";
            figAuto_box.SizeMode = PictureBoxSizeMode.StretchImage;
            figAuto_box.BackColor = Color.Transparent;
            figAuto_box.Location = new Point(x_auto, y_auto);
            figAuto_box.Size = new Size(w_auto, w_auto);
            figAuto_box.Image = figure_Auto;

            //Init PictureBox figCam_box Properties
            figCam_box.Name = "figCam_box";
            figCam_box.SizeMode = PictureBoxSizeMode.StretchImage;
            figCam_box.BackColor = Color.Transparent;
            figCam_box.Location = new Point(x_cam, y_cam);
            figCam_box.Size = new Size(w_cam, h_cam);
            figCam_box.Image = figure_Cam;

            //Init PictureBox figBat_box Properties
            figBat_box.Name = "figBat_box";
            figBat_box.SizeMode = PictureBoxSizeMode.StretchImage;
            figBat_box.BackColor = Color.Transparent;
            figBat_box.Location = new Point(x_bat, y_bat);
            figBat_box.Size = new Size(w_bat, h_bat);
            figBat_box.Image = figure_Bat;

            //Init Start_button
            //Start_button.BackColor = Color.Transparent;
            Start_button.Font = new Font("Comic Sans MS", 40.0F, FontStyle.Bold);
            Start_button.ForeColor = Color.Black;
            Start_button.Name = "Start_button";
            Start_button.Location = new Point(x_button, y_button);
            Start_button.Size = new Size(w_button, h_button);
            Start_button.Text = "Start";
            Start_button.UseVisualStyleBackColor = true;
            Start_button.Click += new EventHandler(Start_button_Click);

            //Init PictureBox Video_Box Properties
            Video_box.Location = new Point(0, 0);
            Video_box.Dock = DockStyle.Fill;
            Video_box.SizeMode = PictureBoxSizeMode.StretchImage;
            //Video_box.BackgroundImageLayout = ImageLayout.Stretch;
            Video_box.Controls.Add(Up_panel);
            Video_box.Controls.Add(Down_panel);
            Video_box.Controls.Add(Right_panel);
            Video_box.Controls.Add(Left_panel);
            Video_box.Controls.Add(figAuto_box);
            Video_box.Controls.Add(figCam_box);
            Video_box.Controls.Add(figBat_box);
            Video_box.Controls.Add(Start_button);
            Video_box.InitialImage = figure_Bat;

            //Init Form Principal Properties
            //this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
            //this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
            //this.ClientSize = new System.Drawing.Size(321, 237);
            this.Text = "Interfaz";
            this.Name = "Principal";
            this.Controls.Add(Video_box);
            this.StartPosition = FormStartPosition.CenterScreen;
            this.WindowState = FormWindowState.Normal;
            this.FormBorderStyle = FormBorderStyle.None;
            this.Bounds = Screen.PrimaryScreen.Bounds;
            this.Load += new EventHandler(Principal_Load);
            this.Shown += new EventHandler(Principal_Shown);
            this.FormClosing += new FormClosingEventHandler(Principal_FormClosing);
            //this.Resize += new EventHandler(Principal_Resize);
            ((System.ComponentModel.ISupportInitialize)(Video_box)).EndInit();
            this.ResumeLayout(false);
            this.PerformLayout();

            #endregion
        }

        private void Principal_Load(object sender, EventArgs e)
        {
            Debug.WriteLine("Load");

            //Video_box.BackgroundImage = figure_Auto;            
            Video_box.Image = cam_no_vanish;
            //Video_box.InitialImage = figure_Auto;

            Program.EyeXHost.Start();            
        }

        private void Principal_Shown(object sender, EventArgs e)
        {
            Debug.WriteLine("Shown");                      
        }

        private void Principal_Resize(object sender, EventArgs e)
        {
            Debug.WriteLine("Resize");

            //Up_panel.Location = new Point(x_up, y_up);
            //Up_panel.Size = new Size(w_vert, h_vert);

            //Down_panel.Location = new Point(x_down, y_down);
            //Down_panel.Size = new Size(w_vert, h_vert);

            //Right_panel.Location = new Point(x_right, y_right);
            //Right_panel.Size = new Size(w_hor, h_hor);

            //Left_panel.Location = new Point(x_left, y_left);
            //Left_panel.Size = new Size(w_hor, h_hor);

            //figAuto_box.Location = new Point(x_auto, y_auto);
            //figAuto_box.Size = new Size(w_auto, w_auto);
            //figAuto_box.Image = figure_Auto;

            //figCam_box.Location = new Point(x_cam, y_cam);
            //figCam_box.Size = new Size(w_cam, h_cam);
            //figCam_box.Image = figure_Cam;

            //figBat_box.Location = new Point(x_bat, y_bat);
            //figBat_box.Size = new Size(w_bat, h_bat);
            //figBat_box.Image = figure_Bat;            
        }       

        private void Principal_FormClosing(object sender, FormClosingEventArgs e)
        {
            Program.EyeXHost.Dispose();

            if (Car.IsConnect)
            {
                //while (!wifly.Client_nobussy) ;

                //// envio "o" para avisarle al microcontrolador que se esta cerrando el programa y que debe apagar la camara
                //car_move("o");

                //// espero que el mensaje se envie
                //while (!wifly.Client_nobussy) ;  
            }

            if (Car != null)
            {      
                Car.closing();
                Car = null;
            }  

            if (Request_timer != null)
            {
                Request_timer.Stop(); ;
                Request_timer.Tick -= Bateria_Request;
                Request_timer = null;
            }
            
            if(Cam != null)
            {
                Cam.Closing();
                Cam = null;
            }
            
            if(LoadForm != null)
            {
                LoadForm.Close();
                LoadForm.Dispose();
                LoadForm = null;
            }            
        }

        private void Start_button_Click(object sender, EventArgs e)
        {
            LoadForm.Show();
            LoadForm.Activate();

            Video_box.Controls.Remove(Start_button);

            // Empezar timer para revisar bateria
            //Request_timer.Start();
        }

        private void OnGazeMove(object sender, GazeAwareEventArgs e)
        {
            var panel = sender as Panel;
            if (panel != null)
            {
                #region Up Panel
                if (panel.Name == Up_panel.Name)
                {
                    if (Mode == Cam_Mode)
                    {
                        if (e.HasGaze)
                        {
                            panel.BackColor = red;
                            Cam.Move("Up");
                        }
                        else
                        {
                            panel.BackColor = green;
                            Cam.Move("Stop");
                        }
                    }
                    else
                    {
                        if (e.HasGaze)
                        {
                            panel.BackColor = red;
                            //Car.Move("Up");
                        }
                        else
                        {
                            panel.BackColor = green;
                           // Car.Move("Stop");
                        }
                    }
                }
                #endregion

                #region Down Panel
                else if (panel.Name == Down_panel.Name)
                {
                    if (Mode == Cam_Mode)
                    {
                        if (e.HasGaze)
                        {
                            panel.BackColor = red;
                            Cam.Move("Down");
                        }
                        else
                        {
                            panel.BackColor = green;
                            Cam.Move("Stop");
                        }
                    }
                    else
                    {
                        if (e.HasGaze)
                        {
                            panel.BackColor = red;
                            //Car.Move("Down");
                        }
                        else
                        {
                            panel.BackColor = green;
                            //Car.Move("Stop");
                        }
                    }
                }
                #endregion

                #region Right Panel
                else if (panel.Name == Right_panel.Name)
                {
                    if (Mode == Cam_Mode)
                    {
                        if (e.HasGaze)
                        {
                            panel.BackColor = red;
                            Cam.Move("Right");
                        }
                        else
                        {
                            panel.BackColor = green;
                            Cam.Move("Stop");
                        }
                    }
                    else
                    {
                        if (e.HasGaze)
                        {
                            panel.BackColor = red;
                            //Car.Move("Right");
                        }
                        else
                        {
                            panel.BackColor = green;
                            //Car.Move("Stop");
                        }
                    }
                }
                #endregion

                #region Left Panel
                else if (panel.Name == Left_panel.Name)
                {
                    if (Mode == Cam_Mode)
                    {
                        if (e.HasGaze)
                        {
                            panel.BackColor = red;
                            Cam.Move("Left");
                        }
                        else
                        {
                            panel.BackColor = green;
                            Cam.Move("Stop");
                        }
                    }
                    else
                    {
                        if (e.HasGaze)
                        {
                            panel.BackColor = red;
                            //Car.Move("Left");
                        }
                        else
                        {
                            panel.BackColor = green;
                            //Car.Move("Stop");
                        }
                    }
                }
                #endregion
            }
        }

        private void OnGazeMode(object sender, GazeAwareEventArgs e)
        {
            var picture = sender as PictureBox;
            if (picture != null)
            {
                if (picture.Name == figAuto_box.Name)
                {
                    if (e.HasGaze)
                    {
                        figAuto_box.Image = auto_no_vanish;
                        figCam_box.Image = cam_vanish;
                        Cam.Move("Preset_1");
                        Mode = Car_Mode;
                    }
                }

                else if (picture.Name == figCam_box.Name)
                {
                    if (e.HasGaze)
                    {
                        figAuto_box.Image = auto_vanish;
                        figCam_box.Image = cam_no_vanish;
                        Mode = Cam_Mode;
                    }
                }
                
            }
        }

        // Metodo para pedir el valor de la bateria del auto
        public void Bateria_Request(object sender, EventArgs e)
        {
            if (Car != null) //Comunicacion == "WiFly")
            {
                Car.Request();
            }
        }
        
        private void wifly_ConnectionEvent(BoolEventArgs e)
        {
            LoadForm.wifly_Connection_End(e.Bool);
        }

        private void Cam_FoundEvent(BoolEventArgs e)
        {
            LoadForm.Cam_Founding_End(e.Bool);
        }

        private void Cam_ConnectEvent(BoolEventArgs e)
        {
            LoadForm.Cam_Connecting_End(e.Bool);
        }

        private void Cam_VideoFrame(NewVideoFrameEventArgs e)
        {
            Video_box.Image = e.frame;
        }


        
    }

}
